Index: palm/trunk/SOURCE/time_integration.f90
===================================================================
--- palm/trunk/SOURCE/time_integration.f90	(revision 1959)
+++ palm/trunk/SOURCE/time_integration.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar
 ! 
 ! Former revisions:
@@ -225,6 +225,6 @@
     USE arrays_3d,                                                             &
         ONLY:  diss, dzu, e, e_p, nr_p, prho, pt, pt_p, pt_init, q_init, q,    &
-               ql, ql_c, ql_v, ql_vp, qr_p, q_p, ref_state, rho, sa_p, tend,   &
-               u, u_p, v, vpt, v_p, w, w_p
+               ql, ql_c, ql_v, ql_vp, qr_p, q_p, ref_state, rho, s, s_p, sa_p, &
+               tend, u, u_p, v, vpt, v_p, w, w_p
 
     USE calc_mean_profile_mod,                                                 &
@@ -532,7 +532,7 @@
                    CALL exchange_horiz( sa_p, nbgp )
                    CALL exchange_horiz( rho, nbgp )
-                  CALL exchange_horiz( prho, nbgp )
-                ENDIF
-                IF (humidity  .OR.  passive_scalar)  THEN
+                   CALL exchange_horiz( prho, nbgp )
+                ENDIF
+                IF ( humidity )  THEN
                    CALL exchange_horiz( q_p, nbgp )
                    IF ( cloud_physics .AND. microphysics_seifert )  THEN
@@ -551,4 +551,5 @@
                    CALL exchange_horiz( diss, nbgp )
                 ENDIF
+                IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
 
                 IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
@@ -601,5 +602,5 @@
                   CALL exchange_horiz( prho, nbgp )
                 ENDIF
-                IF (humidity  .OR.  passive_scalar)  THEN
+                IF ( humidity )  THEN
                    CALL exchange_horiz( q_p, nbgp )
                    IF ( cloud_physics .AND. microphysics_seifert )  THEN
@@ -618,4 +619,5 @@
                    CALL exchange_horiz( diss, nbgp )
                 ENDIF
+                IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )
 
                 IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
@@ -690,5 +692,5 @@
                 CALL exchange_horiz( prho, nbgp )
              ENDIF
-             IF (humidity  .OR.  passive_scalar)  THEN
+             IF ( humidity )  THEN
                 CALL exchange_horiz( q_p, nbgp )
                 IF ( cloud_physics .AND. microphysics_seifert )  THEN
@@ -707,4 +709,5 @@
                 CALL exchange_horiz( diss, nbgp )
              ENDIF
+             IF ( passive_scalar )  CALL exchange_horiz( s_p, nbgp )      
 
              IF ( numprocs == 1 )  THEN    ! workaround for single-core GPU runs
@@ -746,11 +749,8 @@
                 CALL exchange_horiz( v, nbgp )
                 CALL exchange_horiz( w, nbgp )
-                IF ( .NOT. neutral )  THEN
-                   CALL exchange_horiz( pt, nbgp )
-                ENDIF
-                IF ( humidity  .OR.  passive_scalar )  THEN
-                   CALL exchange_horiz( q, nbgp )
-                ENDIF
-                IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp )
+                IF ( .NOT. neutral            )  CALL exchange_horiz( pt, nbgp )
+                IF ( humidity                 )  CALL exchange_horiz( q, nbgp  )
+                IF ( passive_scalar           )  CALL exchange_horiz( s, nbgp  )
+                IF ( .NOT. constant_diffusion )  CALL exchange_horiz( e, nbgp  )
              ENDIF
 !
Index: palm/trunk/SOURCE/user_actions.f90
===================================================================
--- palm/trunk/SOURCE/user_actions.f90	(revision 1959)
+++ palm/trunk/SOURCE/user_actions.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! ------------------
-! 
+! New CASE statement for scalar tendency
 ! 
 ! Former revisions:
@@ -170,4 +170,7 @@
 
           CASE ( 'q-tendency' )
+          
+          
+          CASE ( 's-tendency' )          
 
 
@@ -228,4 +231,7 @@
 
           CASE ( 'q-tendency' )
+          
+          
+          CASE ( 's-tendency' )
 
 
Index: palm/trunk/SOURCE/user_spectra.f90
===================================================================
--- palm/trunk/SOURCE/user_spectra.f90	(revision 1959)
+++ palm/trunk/SOURCE/user_spectra.f90	(revision 1960)
@@ -19,5 +19,5 @@
 ! Current revisions:
 ! -----------------
-! 
+! Consider additional spectra for passive scalar
 ! 
 ! Former revisions:
@@ -89,5 +89,5 @@
        SELECT CASE ( TRIM( data_output_sp(m) ) )
           
-          CASE ( 'u', 'v', 'w', 'pt', 'q' )
+          CASE ( 'u', 'v', 'w', 'pt', 'q', 's' )
 !--          Not allowed here since these are the standard quantities used in 
 !--          preprocess_spectra.
@@ -108,5 +108,5 @@
        SELECT CASE ( TRIM( data_output_sp(m) ) )
 
-          CASE ( 'u', 'v', 'w', 'pt', 'q' )
+          CASE ( 'u', 'v', 'w', 'pt', 'q', 's' )
 !--          Not allowed here since these are the standard quantities used in 
 !--          data_output_spectra.
Index: palm/trunk/SOURCE/virtual_flight_mod.f90
===================================================================
--- palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 1959)
+++ palm/trunk/SOURCE/virtual_flight_mod.f90	(revision 1960)
@@ -19,5 +19,6 @@
 ! Current revisions:
 ! ------------------
-! 
+! Separate humidity and passive scalar.
+! Bugfix concerning labeling of timeseries.
 ! 
 ! Former revisions:
@@ -326,4 +327,11 @@
        
        INTEGER(iwp) ::  i               !< loop variable
+       INTEGER(iwp) ::  id_pt           !< identifyer for labeling
+       INTEGER(iwp) ::  id_q            !< identifyer for labeling
+       INTEGER(iwp) ::  id_ql           !< identifyer for labeling
+       INTEGER(iwp) ::  id_s            !< identifyer for labeling        
+       INTEGER(iwp) ::  id_u = 1        !< identifyer for labeling  
+       INTEGER(iwp) ::  id_v = 2        !< identifyer for labeling
+       INTEGER(iwp) ::  id_w = 3        !< identifyer for labeling
        INTEGER(iwp) ::  k               !< index variable
        
@@ -332,7 +340,20 @@
 !--    Define output quanities, at least three variables are measured (u,v,w)
        num_var_fl = 3
-       IF ( .NOT. neutral )                      num_var_fl = num_var_fl + 1
-       IF ( humidity .OR. passive_scalar )       num_var_fl = num_var_fl + 1
-       IF ( cloud_physics .OR. cloud_droplets )  num_var_fl = num_var_fl + 1  
+       IF ( .NOT. neutral                     )  THEN
+          num_var_fl = num_var_fl + 1
+          id_pt      = num_var_fl
+       ENDIF
+       IF ( humidity                          )  THEN
+          num_var_fl = num_var_fl + 1
+          id_q       = num_var_fl
+       ENDIF
+       IF ( cloud_physics .OR. cloud_droplets )  THEN
+          num_var_fl = num_var_fl + 1  
+          id_ql      = num_var_fl
+       ENDIF
+       IF ( passive_scalar                    )  THEN
+          num_var_fl = num_var_fl + 1
+          id_s       = num_var_fl
+       ENDIF
 !
 !--    Write output strings for dimensions x, y, z
@@ -364,38 +385,33 @@
           DO i=1, num_var_fl
 
-             SELECT CASE ( i )
-                      
-                CASE( 1 )
-                   dofl_label(k) = TRIM( label_leg ) // '_u'
-                   dofl_unit(k)  = 'm/s'
-                   k             = k + 1
-
-                CASE( 2 )
-                   dofl_label(k) = TRIM( label_leg ) // '_v'
-                   dofl_unit(k)  = 'm/s'
-                   k             = k + 1
-
-                CASE( 3 )
-                   dofl_label(k) = TRIM( label_leg ) // '_w'
-                   dofl_unit(k)  = 'm/s'
-                   k             = k + 1
-
-                CASE( 4 )
-                   dofl_label(k) = TRIM( label_leg ) // '_pt'
-                   dofl_unit(k)  = 'K'
-                   k             = k + 1
-
-                CASE( 5 )
-                   dofl_label(k) = TRIM( label_leg ) // '_q'
-                   dofl_unit(k)  = 'kg/kg'
-                   k             = k + 1
-
-                CASE( 6 )
-                   dofl_label(k) = TRIM( label_leg ) // '_ql'
-                   dofl_unit(k)  = 'kg/kg'
-                   k             = k + 1
-
-             END SELECT
-
+             IF ( i == id_u      )  THEN         
+                dofl_label(k) = TRIM( label_leg ) // '_u'
+                dofl_unit(k)  = 'm/s'
+                k             = k + 1
+             ELSEIF ( i == id_v  )  THEN       
+                dofl_label(k) = TRIM( label_leg ) // '_v'
+                dofl_unit(k)  = 'm/s'
+                k             = k + 1
+             ELSEIF ( i == id_w  )  THEN          
+                dofl_label(k) = TRIM( label_leg ) // '_w'
+                dofl_unit(k)  = 'm/s'
+                k             = k + 1
+             ELSEIF ( i == id_pt )  THEN       
+                dofl_label(k) = TRIM( label_leg ) // '_pt'
+                dofl_unit(k)  = 'K'
+                k             = k + 1
+             ELSEIF ( i == id_q  )  THEN       
+                dofl_label(k) = TRIM( label_leg ) // '_q'
+                dofl_unit(k)  = 'kg/kg'
+                k             = k + 1
+             ELSEIF ( i == id_ql )  THEN       
+                dofl_label(k) = TRIM( label_leg ) // '_ql'
+                dofl_unit(k)  = 'kg/kg'
+                k             = k + 1
+             ELSEIF ( i == id_s  )  THEN                          
+                dofl_label(k) = TRIM( label_leg ) // '_s'
+                dofl_unit(k)  = 'kg/kg'
+                k             = k + 1
+             ENDIF
           ENDDO
           
@@ -421,5 +437,5 @@
 
        USE arrays_3d,                                                          &
-           ONLY:  ddzu, ddzw, pt, q, ql, u, v, w, zu, zw
+           ONLY:  ddzu, ddzw, pt, q, ql, s, u, v, w, zu, zw
 
        USE control_parameters,                                                 &
@@ -596,6 +612,6 @@
                 ENDIF
 !
-!--             Humidity or passive scalar
-                IF ( humidity .OR. passive_scalar )  THEN
+!--             Humidity
+                IF ( humidity )  THEN
                    CALL interpolate_xyz( q, zu, ddzu, 1.0_wp, x, y, var_index, j, i )
                    var_index = var_index + 1
@@ -605,4 +621,10 @@
                 IF ( cloud_physics .OR. cloud_droplets )  THEN
                    CALL interpolate_xyz( ql, zu, ddzu, 1.0_wp, x, y, var_index, j, i )
+                   var_index = var_index + 1
+                ENDIF
+!
+!--             Passive scalar
+                IF ( passive_scalar )  THEN
+                   CALL interpolate_xyz( s, zu, ddzu, 1.0_wp, x, y, var_index, j, i )
                    var_index = var_index + 1
                 ENDIF
Index: palm/trunk/SOURCE/write_3d_binary.f90
===================================================================
--- palm/trunk/SOURCE/write_3d_binary.f90	(revision 1959)
+++ palm/trunk/SOURCE/write_3d_binary.f90	(revision 1960)
@@ -100,8 +100,8 @@
         ONLY:  e, kh, km, ol, p, pt, q, ql, qc, nr, nrs, nrsws, nrswst,        &
                prr, precipitation_amount, qr,                                  &
-               qrs, qrsws, qrswst, qs, qsws, qswst, sa, saswsb, saswst,        &
-               rif_wall, shf, ts, tswst, u, u_m_l, u_m_n, u_m_r, u_m_s, us,    &
-               usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s, vpt, vsws, vswst,   &
-               w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
+               qrs, qrsws, qrswst, qs, qsws, qswst, s, sa, ssws, sswst,        &
+               saswsb, saswst, rif_wall, shf, ss, ts, tswst, u, u_m_l, u_m_n,  &
+               u_m_r, u_m_s, us, usws, uswst, v, v_m_l, v_m_n, v_m_r, v_m_s,   &
+               vpt, vsws, vswst, w, w_m_l, w_m_n, w_m_r, w_m_s, z0, z0h, z0q
         
     USE averaging
@@ -237,5 +237,5 @@
        WRITE ( 14 )  'pt_av               ';  WRITE ( 14 )  pt_av
     ENDIF
-    IF ( humidity  .OR. passive_scalar )  THEN
+    IF ( humidity )  THEN
        WRITE ( 14 )  'q                   ';  WRITE ( 14 )  q 
        IF ( ALLOCATED( q_av ) )  THEN
@@ -277,4 +277,16 @@
        WRITE ( 14 )  'qswst               ';  WRITE ( 14 ) qswst
     ENDIF
+    IF ( passive_scalar )  THEN
+       WRITE ( 14 )  's                   ';  WRITE ( 14 )  s 
+       IF ( ALLOCATED( s_av ) )  THEN
+          WRITE ( 14 )  's_av                ';  WRITE ( 14 )  s_av
+       ENDIF
+       WRITE ( 14 )  'ss                  ';  WRITE ( 14 )  ss
+       WRITE ( 14 )  'ssws                ';  WRITE ( 14 )  ssws
+       IF ( ALLOCATED( ssws_av ) )  THEN
+          WRITE ( 14 )  'ssws_av             ';  WRITE ( 14 )  ssws_av
+       ENDIF
+       WRITE ( 14 )  'sswst               ';  WRITE ( 14 ) sswst
+    ENDIF    
     IF ( land_surface )  THEN
        IF ( ALLOCATED( qsws_eb_av ) )  THEN
Index: palm/trunk/SOURCE/write_var_list.f90
===================================================================
--- palm/trunk/SOURCE/write_var_list.f90	(revision 1959)
+++ palm/trunk/SOURCE/write_var_list.f90	(revision 1960)
@@ -154,5 +154,5 @@
     USE arrays_3d,                                                             &
         ONLY:  inflow_damping_factor, mean_inflow_profiles, pt_init,           &
-               q_init, ref_state, sa_init, u_init, ug, v_init, vg
+               q_init, ref_state, s_init, sa_init, u_init, ug, v_init, vg
 
     USE control_parameters
@@ -504,4 +504,16 @@
     WRITE ( 14 )  'run_coupled                   '
     WRITE ( 14 )  run_coupled
+    WRITE ( 14 )  's_init                        '
+    WRITE ( 14 )  s_init
+    WRITE ( 14 )  's_surface                     '
+    WRITE ( 14 )  s_surface
+    WRITE ( 14 )  's_surface_initial_change      '
+    WRITE ( 14 )  s_surface_initial_change
+    WRITE ( 14 )  's_vertical_gradient           '
+    WRITE ( 14 )  s_vertical_gradient
+    WRITE ( 14 )  's_vertical_gradient_level     '
+    WRITE ( 14 )  s_vertical_gradient_level
+    WRITE ( 14 )  's_vertical_gradient_level_ind '
+    WRITE ( 14 )  s_vertical_gradient_level_ind 
     WRITE ( 14 )  'sa_init                       '
     WRITE ( 14 )  sa_init
